@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

rem these values need adjustment:
rem Set this to the right device. "cdrecord -scanbus" is your friend
set CDR_DEVICE=1,0,0
rem Maximum CD writing speed in multiple of 150k/s
set CD_SPEED=32
rem Maximum DvD writing speed in multiple of 1.3MB/s
set DVD_SPEED=12
rem RAM-Buffer FiFo size
set CDR_FIFOSIZE=128m

rem you should not need to edit anything below this line

DEL %TEMP%\CopyCDtmp.ISO 1>NUL 2>NUL
:readcd
echo/
echo ==========================================
echo Bitte Original CD/DvD einlegen!
echo ==========================================
echo/
rem wait until a disk is in the drive
:wait
rem isoinfo needs to be used because it does not close the tray
"%~sdp0isoinfo" dev=%CDR_DEVICE% -d 2>&1|find /i "(medium not present" >NUL && (
  rem ping waits one second
  ping -n 1 127.0.0.1>nul
  goto wait
)
rem check if medium is empty
"%~sdp0cdrecord" -minfo 2>&1|find /i "disk status:              empty" >NUL && (
  echo ##########################################
  echo Fehler: Das Medium ist leer! 
  echo ##########################################
:eject
  "%~sdp0cdrecord" -eject 1>NUL 2>NUL 
  goto readcd
)
rem Get CD/DvD Type
SET DISKTYPE=CD
"%~sdp0cdrecord" -minfo 2>&1|find /i "Mounted media class:      DVD" >NUL && SET DISKTYPE=DvD
echo/
echo ==========================================
echo Lese %DISKTYPE%
echo ==========================================
echo/
rem read CD/DvD
"%~sdp0readcd" -s f=%TEMP%\CopyCDtmp.ISO || (
  echo/
  echo ##########################################
  echo Lesefehler!
  echo ##########################################
  echo/
  rem read error: delete ISO
  del %TEMP%\CopyCDtmp.ISO 1>NUL 2>NUL
  goto eject
)
:burn
"%~sdp0cdrecord" -eject 1>NUL 2>NUL 
if NOT exist %TEMP%\CopyCDtmp.ISO goto readcd
echo/
echo ==========================================
echo Bitte leeren %DISKTYPE% Rohling einlegen.
echo ==========================================
echo/
rem wait until an empty disk is in the drive
:wait1
rem isoinfo needs to be used because it does not close the tray
"%~sdp0isoinfo" dev=%CDR_DEVICE% -d 2>&1|find /i "(medium not present" >NUL && (
  rem ping waits one second
  ping -n 1 127.0.0.1>nul
  goto wait1
)
rem check if medium is empty
"%~sdp0cdrecord" -minfo 2>&1|find /i "disk status:              empty" >NUL || (
  echo ##########################################
  echo Fehler: Das Medium ist NICHT leer!
  echo ##########################################
  goto burn
)
rem Verify CD/DvD Type and set write speed
set CDR_SPEED=%CD_SPEED%
"%~sdp0cdrecord" -minfo 2>&1|find /i "Mounted media class:      DVD" >NUL && CDR_SPEED=%DVD_SPEED%
IF CDR_SPEED EQU %DVD_SPEED% (
  if "DISKTYPE"=="CD" (
    echo/
    echo ##########################################
    echo      Fehler! DvD Rohling eingelegt!
    echo ##########################################
    echo/
    goto burn
  )
)ELSE (
  if "DISKTYPE"=="DvD" (
    echo/
    echo ##########################################
    echo      Fehler! CD Rohling eingelegt!
    echo ##########################################
    echo/
    goto burn
  )
)
rem write ISO to CD/DvD, eject tray and delete ISO
"%~sdp0cdrecord" -dao -gracetime=2 -s driveropts=burnfree %TEMP%\CopyCDtmp.ISO || (
  del %TEMP%\CopyCDtmp.ISO 1>NUL 2>NUL 
  echo/
  echo ==========================================
  echo            Schreibfehler!
  echo ==========================================
  echo/
  rem write error: do not delete iso an try again
  goto burn
)
echo/
echo ==========================================
echo            Fertig.
echo ==========================================
echo/
goto eject
