@echo off
SETLOCAL ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

rem these values need adjustment:
rem Set this to the right device. "cdrecord -scanbus" is your friend
set CDR_DEVICE=1,0,0

rem you should not need to edit anything below this line

:readcd
echo/
echo ==========================================
echo Bitte Original CD/DvD einlegen!
echo ==========================================
echo/
rem wait until a disk is in the drive
:wait
rem isoinfo needs to be used because it does not close the tray
%~sdp0isoinfo dev=%CDR_DEVICE% -d 2>&1|find /i "(medium not present" >NUL && (
  rem ping waits one second
  ping -n 1 127.0.0.1>nul
  goto wait
)
rem check if medium is empty
%~sdp0cdrecord -minfo 2>&1|find /i "disk status:              empty" >NUL && (
  echo ##########################################
  echo Fehler: Das Medium ist leer! 
  echo ##########################################
  goto eject
)
for /f "tokens=1,2,3*" %%A in ('%~sdp0isoinfo "dev=%CDR_DEVICE%" -d 2^>^&1') do (
  if "%%A"=="Volume" if "%%B"=="id:" SET ISONAME=%%C.ISO
)
if "%ISONAME%"=="" (
  echo ##########################################
  echo Fehler: Das Medium hat keinen Namen! 
  echo ##########################################
  goto eject
)
echo/
echo ==========================================
echo Speichere "%ISONAME%"
echo ------------------------------------------
rem read CD/DvD
%~sdp0readcd -s f="%ISONAME%" || (
  rem read error: delete ISO
  del "%ISONAME%"
  echo ##########################################
  echo Lesefehler!
  echo ##########################################
  echo/
  goto eject
)
echo ------------------------------------------
echo            Fertig.
echo ==========================================
echo/
:eject
%~sdp0cdrecord -eject 1>NUL 2>NUL 
goto readcd
